xref: /titanic_51/usr/src/tools/scripts/nightly.sh (revision 38e9bdff89ac3db1d2adb25900776c2cbb6a3438)
1#!/bin/ksh -p
2#
3# CDDL HEADER START
4#
5# The contents of this file are subject to the terms of the
6# Common Development and Distribution License (the "License").
7# You may not use this file except in compliance with the License.
8#
9# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
10# or http://www.opensolaris.org/os/licensing.
11# See the License for the specific language governing permissions
12# and limitations under the License.
13#
14# When distributing Covered Code, include this CDDL HEADER in each
15# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
16# If applicable, add the following below this CDDL HEADER, with the
17# fields enclosed by brackets "[]" replaced with your own identifying
18# information: Portions Copyright [yyyy] [name of copyright owner]
19#
20# CDDL HEADER END
21#
22#
23# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
24# Use is subject to license terms.
25#
26# ident	"%Z%%M%	%I%	%E% SMI"
27#
28# Based on the nightly script from the integration folks,
29# Mostly modified and owned by mike_s.
30# Changes also by kjc, dmk.
31#
32# BRINGOVER_WS may be specified in the env file.
33# The default is the old behavior of CLONE_WS
34#
35# -i on the command line, means fast options, so when it's on the
36# command line (only), lint and check builds are skipped no matter what
37# the setting of their individual flags are in NIGHTLY_OPTIONS.
38#
39# LINTDIRS can be set in the env file, format is a list of:
40#
41#	/dirname-to-run-lint-on flag
42#
43#	Where flag is:	y - enable lint noise diff output
44#			n - disable lint noise diff output
45#
46#	For example: LINTDIRS="$SRC/uts n $SRC/stand y $SRC/psm y"
47#
48# -A flag in NIGHTLY_OPTIONS checks ABI diffs in .so files
49# This option requires a couple of scripts.
50#
51# OPTHOME and TEAMWARE may be set in the environment to override /opt
52# and /opt/teamware defaults.
53#
54
55#
56# The CDPATH variable causes ksh's `cd' builtin to emit messages to stdout
57# under certain circumstances, which can really screw things up; unset it.
58#
59unset CDPATH
60
61# function to do a DEBUG and non-DEBUG build. Needed because we might
62# need to do another for the source build, and since we only deliver DEBUG or
63# non-DEBUG packages.
64
65normal_build() {
66
67	# timestamp the start of a nightly build; the findunref tool uses it.
68	touch $SRC/.build.tstamp
69
70	# non-DEBUG build begins
71
72	if [ "$F_FLAG" = "n" ]; then
73		export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
74		export RELEASE_BUILD ; RELEASE_BUILD=
75		unset EXTRA_OPTIONS
76		unset EXTRA_CFLAGS
77
78		build non-DEBUG -nd
79
80		if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a "$p_FLAG" = "y" ]; then
81			copy_ihv_pkgs non-DEBUG -nd
82		fi
83	else
84		echo "\n==== No non-DEBUG build ====\n" >> $LOGFILE
85	fi
86
87	# non-DEBUG build ends
88
89	# DEBUG build begins
90
91	if [ "$D_FLAG" = "y" ]; then
92
93		export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
94		unset RELEASE_BUILD
95		unset EXTRA_OPTIONS
96		unset EXTRA_CFLAGS
97
98		build DEBUG ""
99
100		if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a "$p_FLAG" = "y" ]; then
101			copy_ihv_pkgs DEBUG ""
102		fi
103
104	else
105		echo "\n==== No DEBUG build ====\n" >> $LOGFILE
106	fi
107
108	# DEBUG build ends
109}
110
111filelist() {
112	if  [ $# -ne 2 ]; then
113		echo "usage: filelist DESTDIR PATTERN"
114		exit 1;
115	fi
116	DEST=$1
117	PATTERN=$2
118	cd ${DEST}
119
120	OBJFILES=${ORIG_SRC}/xmod/obj_files
121	if [ ! -f ${OBJFILES} ]; then
122		return;
123	fi
124	for i in `grep -v '^#' ${ORIG_SRC}/xmod/obj_files | \
125	    grep ${PATTERN} | cut -d: -f2 | tr -d ' \t'`
126	do
127		# wildcard expansion
128		for j in $i
129		do
130			if [ -f "$j" ]; then
131				echo $j
132			fi
133			if [ -d "$j" ]; then
134				echo $j
135			fi
136		done
137	done | sort | uniq
138}
139
140# function to save off binaries after a full build for later
141# restoration
142save_binaries() {
143	# save off list of binaries
144	echo "\n==== Saving binaries from build at `date` ====\n" | \
145	    tee -a $mail_msg_file >> $LOGFILE
146	rm -f ${BINARCHIVE}
147	cd ${CODEMGR_WS}
148	filelist ${CODEMGR_WS} '^preserve:' >> $LOGFILE
149	filelist ${CODEMGR_WS} '^preserve:' | \
150	    cpio -ocB 2>/dev/null | compress \
151	    > ${BINARCHIVE}
152}
153
154# delete files
155hybridize_files() {
156	if  [ $# -ne 2 ]; then
157		echo "usage: hybridize_files DESTDIR MAKE_TARGET"
158		exit 1;
159	fi
160
161	DEST=$1
162	MAKETARG=$2
163
164	echo "\n==== Hybridizing files at `date` ====\n" | \
165	    tee -a $mail_msg_file >> $LOGFILE
166	for i in `filelist ${DEST} '^delete:'`
167	do
168		echo "removing ${i}." | tee -a $mail_msg_file >> $LOGFILE
169		rm -rf "${i}"
170	done
171	for i in `filelist ${DEST} '^hybridize:' `
172	do
173		echo "hybridizing ${i}." | tee -a $mail_msg_file >> $LOGFILE
174		rm -f ${i}+
175		sed -e "/^# HYBRID DELETE START/,/^# HYBRID DELETE END/d" \
176		    < ${i} > ${i}+
177		mv ${i}+ ${i}
178	done
179}
180
181# restore binaries into the proper source tree.
182restore_binaries() {
183	if  [ $# -ne 2 ]; then
184		echo "usage: restore_binaries DESTDIR MAKE_TARGET"
185		exit 1;
186	fi
187
188	DEST=$1
189	MAKETARG=$2
190
191	echo "\n==== Restoring binaries to ${MAKETARG} at `date` ====\n" | \
192	    tee -a $mail_msg_file >> $LOGFILE
193	cd ${DEST}
194	zcat ${BINARCHIVE} | \
195	    cpio -idmucvB 2>/dev/null | tee -a $mail_msg_file >> ${LOGFILE}
196}
197
198# rename files we save binaries of
199rename_files() {
200	if  [ $# -ne 2 ]; then
201		echo "usage: rename_files DESTDIR MAKE_TARGET"
202		exit 1;
203	fi
204
205	DEST=$1
206	MAKETARG=$2
207	echo "\n==== Renaming source files in ${MAKETARG} at `date` ====\n" | \
208	    tee -a $mail_msg_file >> $LOGFILE
209	for i in `filelist ${DEST} '^rename:'`
210	do
211		echo ${i} | tee -a $mail_msg_file >> ${LOGFILE}
212		rm -f ${i}.export
213		mv ${i} ${i}.export
214	done
215}
216
217# function to create the export/crypt source tree
218# usage: clone_source CODEMGR_WS DESTDIR MAKE_TARGET
219
220clone_source() {
221
222	if  [ $# -ne 3 ]; then
223		echo "usage: clone_source CODEMGR_WS DESTDIR MAKE_TARGET"
224		exit 1;
225	fi
226	WS=$1
227	DEST=$2
228	MAKETARG=$3
229
230	echo "\n==== Creating ${DEST} source from ${WS} (${MAKETARG}) ====\n" | \
231	    tee -a $mail_msg_file >> $LOGFILE
232
233	echo "cleaning out ${DEST}." >> $LOGFILE
234	rm -rf "${DEST}" >> $LOGFILE 2>&1
235
236	mkdir -p ${DEST}
237	cd ${WS}
238
239	echo "creating ${DEST}." >> $LOGFILE
240	find usr -name 's\.*' -a -type f -print | \
241	    sed -e 's,SCCS\/s.,,' | \
242	    grep -v '/\.del-*' | \
243	    cpio -pd ${DEST} >>$LOGFILE 2>&1
244
245	SRC=${DEST}/usr/src
246
247	cd $SRC
248	rm -f ${MAKETARG}.out
249	echo "making ${MAKETARG} in ${SRC}." >> $LOGFILE
250	/bin/time $MAKE -e ${MAKETARG} 2>&1 | \
251	    tee -a $SRC/${MAKETARG}.out >> $LOGFILE
252	echo "\n==== ${MAKETARG} build errors ====\n" >> $mail_msg_file
253	egrep ":" $SRC/${MAKETARG}.out | \
254		egrep -e "(^${MAKE}:|[ 	]error[: 	\n])" | \
255		egrep -v "Ignoring unknown host" | \
256		egrep -v "warning" >> $mail_msg_file
257
258	echo "clearing state files." >> $LOGFILE
259	find . -name '.make*' -exec rm -f {} \;
260
261	cd ${DEST}
262	if [ "${MAKETARG}" = "CRYPT_SRC" ]; then
263		rm -f ${CODEMGR_WS}/crypt_files.cpio.Z
264		echo "\n==== xmod/cry_files that don't exist ====\n" | \
265		    tee -a $mail_msg_file >> $LOGFILE
266		CRYPT_FILES=${WS}/usr/src/xmod/cry_files
267		for i in `cat ${CRYPT_FILES}`
268		do
269			# make sure the files exist
270			if [ -f "$i" ]; then
271				continue
272			fi
273			if [ -d "$i" ]; then
274				continue
275			fi
276			echo "$i" | tee -a $mail_msg_file >> $LOGFILE
277		done
278		find `cat ${CRYPT_FILES}` -print 2>/dev/null | \
279		    cpio -ocB 2>/dev/null | \
280		    compress > ${CODEMGR_WS}/crypt_files.cpio.Z
281	fi
282
283	if [ "${MAKETARG}" = "EXPORT_SRC" ]; then
284		# rename first, since we might restore a file
285		# of the same name (mapfiles)
286		rename_files ${EXPORT_SRC} EXPORT_SRC
287		if [ "$SH_FLAG" = "y" ]; then
288			hybridize_files ${EXPORT_SRC} EXPORT_SRC
289		fi
290	fi
291
292	# save the cleartext
293	echo "\n==== Creating ${MAKETARG}.cpio.Z ====\n" | \
294	    tee -a $mail_msg_file >> $LOGFILE
295	cd ${DEST}
296	rm -f ${MAKETARG}.cpio.Z
297	find usr -depth -print | \
298	    grep -v usr/src/${MAKETARG}.out | \
299	    cpio -ocB 2>/dev/null | \
300	    compress > ${CODEMGR_WS}/${MAKETARG}.cpio.Z
301	if [ "${MAKETARG}" = "EXPORT_SRC" ]; then
302		restore_binaries ${EXPORT_SRC} EXPORT_SRC
303	fi
304
305	if [ "${MAKETARG}" = "CRYPT_SRC" ]; then
306		restore_binaries ${CRYPT_SRC} CRYPT_SRC
307	fi
308
309}
310
311# function to do the build.
312# usage: build LABEL SUFFIX
313
314build() {
315
316	if  [ $# -ne 2 ]; then
317		echo "usage: build LABEL SUFFIX"
318		exit 1;
319	fi
320
321	LABEL=$1
322	SUFFIX=$2
323	INSTALLOG=install${SUFFIX}-${MACH}
324	NOISE=noise${SUFFIX}-${MACH}
325	CPIODIR=${CPIODIR_ORIG}${SUFFIX}
326	PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
327	if [ "$SPARC_RM_PKGARCHIVE_ORIG" ]; then
328		SPARC_RM_PKGARCHIVE=${SPARC_RM_PKGARCHIVE_ORIG}${SUFFIX}
329	fi
330
331	#remove old logs
332	OLDINSTALLOG=install${SUFFIX}
333	OLDNOISE=noise${SUFFIX}
334	rm -f $SRC/${OLDINSTALLOG}.out
335	rm -f $SRC/${OLDNOISE}.ref
336	if [ -f $SRC/${OLDNOISE}.out ]; then
337		mv $SRC/${OLDNOISE}.out $SRC/${NOISE}.ref
338	fi
339
340	this_build_ok=y
341	#
342	#	Build OS-Networking source
343	#
344	echo "\n==== Building OS-Net source at `date` ($LABEL) ====\n" \
345		>> $LOGFILE
346
347	rm -f $SRC/${INSTALLOG}.out
348	cd $SRC
349	/bin/time $MAKE -e install 2>&1 | \
350	    tee -a $SRC/${INSTALLOG}.out >> $LOGFILE
351
352	echo "\n==== SCCS Noise ($LABEL) ====\n" >> $mail_msg_file
353
354	egrep 'sccs(check|  get)' $SRC/${INSTALLOG}.out >> $mail_msg_file
355
356	echo "\n==== Build errors ($LABEL) ====\n" >> $mail_msg_file
357	egrep ":" $SRC/${INSTALLOG}.out |
358		egrep -e "(^${MAKE}:|[ 	]error[: 	\n])" | \
359		egrep -v "Ignoring unknown host" | \
360		egrep -v "cc .* -o error " | \
361		egrep -v "warning" >> $mail_msg_file
362	if [ "$?" = "0" ]; then
363		build_ok=n
364		this_build_ok=n
365	fi
366	grep "bootblock image is .* bytes too big" $SRC/${INSTALLOG}.out \
367		>> $mail_msg_file
368	if [ "$?" = "0" ]; then
369		build_ok=n
370		this_build_ok=n
371	fi
372
373	if [ "$W_FLAG" = "n" ]; then
374		echo "\n==== Build warnings ($LABEL) ====\n" >>$mail_msg_file
375		egrep -i warning: $SRC/${INSTALLOG}.out \
376			| egrep -v '^tic:' \
377			| egrep -v "symbol \`timezone' has differing types:" \
378		        | egrep -v "parameter <PSTAMP> set to" \
379			| egrep -v "Ignoring unknown host" \
380			| egrep -v "redefining segment flags attribute for" \
381			>> $mail_msg_file
382	fi
383
384	echo "\n==== Ended OS-Net source build at `date` ($LABEL) ====\n" \
385		>> $LOGFILE
386
387	echo "\n==== Elapsed build time ($LABEL) ====\n" >>$mail_msg_file
388	tail -3  $SRC/${INSTALLOG}.out >>$mail_msg_file
389
390	if [ "$i_FLAG" = "n" -a "$W_FLAG" = "n" ]; then
391		rm -f $SRC/${NOISE}.ref
392		if [ -f $SRC/${NOISE}.out ]; then
393			mv $SRC/${NOISE}.out $SRC/${NOISE}.ref
394		fi
395		grep : $SRC/${INSTALLOG}.out \
396			| egrep -v '^/' \
397			| egrep -v '^(Start|Finish|real|user|sys|./bld_awk)' \
398			| egrep -v '^tic:' \
399			| egrep -v '^mcs' \
400			| egrep -v '^LD_LIBRARY_PATH=' \
401			| egrep -v 'ar: creating' \
402			| egrep -v 'ar: writing' \
403			| egrep -v 'conflicts:' \
404			| egrep -v ':saved created' \
405			| egrep -v '^stty.*c:' \
406			| egrep -v '^mfgname.c:' \
407			| egrep -v '^uname-i.c:' \
408			| egrep -v '^volumes.c:' \
409			| egrep -v '^lint library construction:' \
410			| egrep -v 'tsort: INFORM:' \
411			| egrep -v 'stripalign:' \
412			| egrep -v 'chars, width' \
413			| egrep -v "symbol \`timezone' has differing types:" \
414			| egrep -v 'PSTAMP' \
415			| egrep -v '|%WHOANDWHERE%|' \
416			| egrep -v '^Manifying' \
417			| egrep -v 'Ignoring unknown host' \
418			| egrep -v 'Processing method:' \
419			| egrep -v '^Writing' \
420			| egrep -v 'spellin1:' \
421			| egrep -v '^adding:' \
422			| egrep -v "^echo 'msgid" \
423			| egrep -v '^echo ' \
424			| egrep -v '\.c:$' \
425			| egrep -v '^Adding file:' \
426			| egrep -v 'CLASSPATH=' \
427			| egrep -v '\/var\/mail\/:saved' \
428			| egrep -v -- '-DUTS_VERSION=' \
429			| egrep -v '^Running Mkbootstrap' \
430			| egrep -v '^Applet length read:' \
431			| egrep -v 'bytes written:' \
432			| egrep -v '^File:SolarisAuthApplet.bin' \
433			| egrep -v -i 'jibversion' \
434			| egrep -v '^Output size:' \
435			| egrep -v '^Solo size statistics:' \
436			| egrep -v '^Using ROM API Version' \
437			| egrep -v '^Zero Signature length:' \
438			| egrep -v '^Note \(probably harmless\):' \
439			| egrep -v '::' \
440			| egrep -v -- '-xcache' \
441			| egrep -v '^\+' \
442			| egrep -v '^cc1: note: -fwritable-strings' \
443			| egrep -v 'svc:/' \
444			| sort | uniq >$SRC/${NOISE}.out
445		if [ ! -f $SRC/${NOISE}.ref ]; then
446			cp $SRC/${NOISE}.out $SRC/${NOISE}.ref
447		fi
448		echo "\n==== Build noise differences ($LABEL) ====\n" \
449			>>$mail_msg_file
450		diff $SRC/${NOISE}.ref $SRC/${NOISE}.out >>$mail_msg_file
451	fi
452
453	#
454	#	Create cpio archives for preintegration testing (PIT)
455	#
456	if [ "$a_FLAG" = "y" -a "$this_build_ok" = "y" ]; then
457		echo "\n==== Creating $LABEL cpio archives at `date` ====\n" \
458			>> $LOGFILE
459		makebfu_file="${TMPDIR}/makebfu"
460		rm -f ${makebfu_file}
461		makebfu 2>&1 | \
462			tee -a ${makebfu_file} >> $LOGFILE
463		echo "\n==== cpio archives build errors ($LABEL) ====\n" \
464			>> $mail_msg_file
465		grep -v "^Creating .* archive:" ${makebfu_file} | \
466			grep -v "^Making" | \
467			grep -v "^$" | \
468			sort | uniq >> $mail_msg_file
469		rm -f ${makebfu_file}
470		# hack for test folks
471		if [ -z "`echo $PARENT_WS|egrep '^\/ws\/'`" ]; then
472			X=/net/`uname -n`${CPIODIR}
473		else
474			X=${CPIODIR}
475		fi
476		echo "Archive_directory: ${X}" >${TMPDIR}/f
477		cp ${TMPDIR}/f ${CPIODIR}/../../.${MACH}_wgtrun
478		rm -f ${TMPDIR}/f
479
480	else
481		echo "\n==== Not creating $LABEL cpio archives ====\n" \
482			>> $LOGFILE
483	fi
484
485	#
486	#	Building Packages
487	#
488	if [ "$p_FLAG" = "y" -a "$this_build_ok" = "y" ]; then
489		echo "\n==== Creating $LABEL packages at `date` ====\n" \
490			>> $LOGFILE
491		rm -f $SRC/pkgdefs/${INSTALLOG}.out
492		echo "Clearing out $PKGARCHIVE ..." >> $LOGFILE
493		rm -rf $PKGARCHIVE
494		mkdir -p $PKGARCHIVE
495
496		#
497		# Optional build of sparc realmode on i386
498		#
499		if [ "$MACH" = "i386" ] && [ "${SPARC_RM_PKGARCHIVE}" ]; then
500			echo "Clearing out ${SPARC_RM_PKGARCHIVE} ..." \
501				>> $LOGFILE
502			rm -rf ${SPARC_RM_PKGARCHIVE}
503			mkdir -p ${SPARC_RM_PKGARCHIVE}
504		fi
505
506		cd $SRC/pkgdefs
507		$MAKE -e install 2>&1 | \
508			tee -a $SRC/pkgdefs/${INSTALLOG}.out >> $LOGFILE
509		echo "\n==== Package build errors ($LABEL) ====\n" \
510			>> $mail_msg_file
511		egrep "${MAKE}|ERROR|WARNING" $SRC/pkgdefs/${INSTALLOG}.out | \
512			grep ':' | \
513			grep -v PSTAMP | \
514			egrep -v "Ignoring unknown host" \
515			>> $mail_msg_file
516	else
517		echo "\n==== Not creating $LABEL packages ====\n" >> $LOGFILE
518	fi
519}
520
521dolint() {
522
523	#
524	# Arg. 2 is a flag to turn on/off the lint diff output
525	#
526	dl_usage="Usage: dolint /dir y|n"
527
528	if [ $# -ne 2 ]; then
529		echo $dl_usage
530		exit 1
531	fi
532
533	if [ ! -d "$1" ]; then
534		echo $dl_usage
535		exit 1
536	fi
537
538	if [ "$2" != "y" -a "$2" != "n" ]; then
539		echo $dl_usage
540		exit 1
541	fi
542
543	lintdir=$1
544	dodiff=$2
545	base=`basename $lintdir`
546	LINTOUT=$lintdir/lint-${MACH}.out
547	LINTNOISE=$lintdir/lint-noise-${MACH}
548
549	export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
550	unset RELEASE_BUILD
551	unset EXTRA_OPTIONS
552	unset EXTRA_CFLAGS
553
554	#
555	#	'$MAKE lint' in $lintdir
556	#
557	echo "\n==== Begin '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
558
559	# remove old lint.out
560	rm -f $lintdir/lint.out $lintdir/lint-noise.out
561	if [ -f $lintdir/lint-noise.ref ]; then
562		mv $lintdir/lint-noise.ref ${LINTNOISE}.ref
563	fi
564
565	rm -f $LINTOUT
566	cd $lintdir
567	#
568	# Remove all .ln files to ensure a full reference file
569	#
570	rm -f Nothing_to_remove \
571	    `find . -name SCCS -prune -o -type f -name '*.ln' -print `
572
573	/bin/time $MAKE -ek lint 2>&1 | \
574	    tee -a $LINTOUT >> $LOGFILE
575	echo "\n==== '$MAKE lint' of $base ERRORS ====\n" >> $mail_msg_file
576	grep "$MAKE:" $LINTOUT |
577		egrep -v "Ignoring unknown host" \
578		>> $mail_msg_file
579
580	echo "\n==== Ended '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
581
582	echo "\n==== Elapsed time of '$MAKE lint' of $base ====\n" \
583		>>$mail_msg_file
584	tail -3  $LINTOUT >>$mail_msg_file
585
586	rm -f ${LINTNOISE}.ref
587	if [ -f ${LINTNOISE}.out ]; then
588		mv ${LINTNOISE}.out ${LINTNOISE}.ref
589	fi
590        grep : $LINTOUT | \
591		egrep -v '^(real|user|sys)' |
592		egrep -v '(library construction)' | \
593		egrep -v ': global crosschecks' | \
594		egrep -v 'Ignoring unknown host' | \
595		egrep -v '\.c:$' | \
596		sort | uniq > ${LINTNOISE}.out
597	if [ ! -f ${LINTNOISE}.ref ]; then
598		cp ${LINTNOISE}.out ${LINTNOISE}.ref
599	fi
600	if [ "$dodiff" != "n" ]; then
601		echo "\n==== lint warnings $base ====\n" \
602			>>$mail_msg_file
603		# should be none, though there are a few that were filtered out
604		# above
605		egrep -i '(warning|lint):' ${LINTNOISE}.out \
606			| sort | uniq >> $mail_msg_file
607		echo "\n==== lint noise differences $base ====\n" \
608			>> $mail_msg_file
609		diff ${LINTNOISE}.ref ${LINTNOISE}.out \
610			>> $mail_msg_file
611	fi
612}
613
614# Install proto area from IHV build
615
616copy_ihv_proto() {
617
618	echo "\n==== Installing $IA32_IHV_ROOT  ====\n" \
619		>> $LOGFILE
620	if [ -d "$IA32_IHV_ROOT" ]; then
621		if [ ! -d "$ROOT" ]; then
622			echo "mkdir -p $ROOT" >> $LOGFILE
623			mkdir -p $ROOT
624		fi
625		echo "cd $IA32_IHV_ROOT\n" >> $LOGFILE
626		cd $IA32_IHV_ROOT
627		tar -cf - . | (cd $ROOT; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
628	else
629		echo "$IA32_IHV_ROOT: not found" >> $LOGFILE
630	fi
631}
632
633# Install IHV packages in PKGARCHIVE
634
635copy_ihv_pkgs() {
636
637	if  [ $# -ne 2 ]; then
638		echo "usage: copy_ihv_pkgs LABEL SUFFIX"
639		exit 1;
640	fi
641
642	LABEL=$1
643	SUFFIX=$2
644	# always use non-DEBUG IHV packages
645	IA32_IHV_PKGS=${IA32_IHV_PKGS_ORIG}-nd
646	PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
647
648	echo "\n==== Installing IHV packages from $IA32_IHV_PKGS ($LABEL) ====\n" \
649		>> $LOGFILE
650	if [ -d "$IA32_IHV_PKGS" ]; then
651		cd $IA32_IHV_PKGS
652		tar -cf - * | \
653		   (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
654	else
655		echo "$IA32_IHV_PKGS: not found" >> $LOGFILE
656	fi
657
658	echo "\n==== Installing IHV packages from $IA32_IHV_BINARY_PKGS ($LABEL) ====\n" \
659		>> $LOGFILE
660	if [ -d "$IA32_IHV_BINARY_PKGS" ]; then
661		cd $IA32_IHV_BINARY_PKGS
662		tar -cf - * | \
663		    (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
664	else
665		echo "$IA32_IHV_BINARY_PKGS: not found" >> $LOGFILE
666	fi
667}
668
669build_tools() {
670
671	if  [ $# -ne 1 ]; then
672		echo "usage: build_tools DESTROOT"
673		exit 1;
674	fi
675
676	DESTROOT=$1
677
678	INSTALLOG=install-${MACH}
679
680	echo "\n==== Building tools at `date` ====\n" \
681		>> $LOGFILE
682
683	rm -f ${TOOLS}/${INSTALLOG}.out
684	cd ${TOOLS}
685	/bin/time $MAKE ROOT=${DESTROOT} -e install 2>&1 | \
686	    tee -a ${TOOLS}/${INSTALLOG}.out >> $LOGFILE
687
688	echo "\n==== Tools build errors ====\n" >> $mail_msg_file
689
690	egrep ":" ${TOOLS}/${INSTALLOG}.out |
691		egrep -e "(${MAKE}:|[ 	]error[: 	\n])" | \
692		egrep -v "Ignoring unknown host" | \
693		egrep -v warning >> $mail_msg_file
694	if [ "$?" != "0" ]; then
695		STABS=${DESTROOT}/opt/onbld/bin/${MACH}/stabs
696		export STABS
697		CTFSTABS=${DESTROOT}/opt/onbld/bin/${MACH}/ctfstabs
698		export CTFSTABS
699		GENOFFSETS=${DESTROOT}/opt/onbld/bin/genoffsets
700		export GENOFFSETS
701
702		CTFCONVERT=${DESTROOT}/opt/onbld/bin/${MACH}/ctfconvert
703		export CTFCONVERT
704		CTFMERGE=${DESTROOT}/opt/onbld/bin/${MACH}/ctfmerge
705		export CTFMERGE
706
707		CTFCVTPTBL=${DESTROOT}/opt/onbld/bin/ctfcvtptbl
708		export CTFCVTPTBL
709		CTFFINDMOD=${DESTROOT}/opt/onbld/bin/ctffindmod
710		export CTFFINDMOD
711
712		if [ "$VERIFY_ELFSIGN" = "y" ]; then
713			ELFSIGN=${DESTROOT}/opt/onbld/bin/elfsigncmp
714		else
715			ELFSIGN=${DESTROOT}/opt/onbld/bin/${MACH}/elfsign
716		fi
717		export ELFSIGN
718
719		PATH="${DESTROOT}/opt/onbld/bin/${MACH}:${PATH}"
720		PATH="${DESTROOT}/opt/onbld/bin:${PATH}"
721		export PATH
722
723		echo "\n==== New environment settings. ====\n" >> $LOGFILE
724		echo "STABS=${STABS}" >> $LOGFILE
725		echo "CTFSTABS=${CTFSTABS}" >> $LOGFILE
726		echo "CTFCONVERT=${CTFCONVERT}" >> $LOGFILE
727		echo "CTFMERGE=${CTFMERGE}" >> $LOGFILE
728		echo "CTFCVTPTBL=${CTFCVTPTBL}" >> $LOGFILE
729		echo "CTFFINDMOD=${CTFFINDMOD}" >> $LOGFILE
730		echo "ELFSIGN=${ELFSIGN}" >> $LOGFILE
731		echo "PATH=${PATH}" >> $LOGFILE
732	fi
733}
734
735staffer() {
736	if [ $ISUSER -ne 0 ]; then
737		"$@"
738	else
739		arg="\"$1\""
740		shift
741		for i
742		do
743			arg="$arg \"$i\""
744		done
745		eval su $STAFFER -c \'$arg\'
746	fi
747}
748
749#
750# Verify that the closed tree is present if it needs to be.
751# Sets CLOSED_IS_PRESENT for future use.
752#
753check_closed_tree() {
754	if [ -z "$CLOSED_IS_PRESENT" ]; then
755		if [ -d $SRC/../closed ]; then
756			CLOSED_IS_PRESENT="yes"
757		else
758			CLOSED_IS_PRESENT="no"
759		fi
760		export CLOSED_IS_PRESENT
761	fi
762	if [[ "$CLOSED_IS_PRESENT" = no && ! -d "$ON_CLOSED_BINS" ]]; then
763		#
764		# If it's an old (pre-split) tree or an empty
765		# workspace, don't complain.
766		#
767		if grep -s CLOSED_BUILD $SRC/Makefile.master > /dev/null; then
768			echo "If the closed sources are not present," \
769			    "ON_CLOSED_BINS"
770			echo "must point to the closed binaries tree."
771			exit 1
772		fi
773	fi
774}
775
776obsolete_build() {
777    	echo "WARNING: Obsolete $1 build requested; request will be ignored"
778}
779
780
781MACH=`uname -p`
782
783if [ "$OPTHOME" = "" ]; then
784	OPTHOME=/opt
785	export OPTHOME
786fi
787if [ "$TEAMWARE" = "" ]; then
788	TEAMWARE=$OPTHOME/teamware
789	export TEAMWARE
790fi
791
792USAGE='Usage: nightly [-in] [-V VERS ] [ -S E|D|H ] <env_file>
793
794Where:
795	-i	Fast incremental options (no clobber, lint, check)
796	-n      Do not do a bringover
797	-V VERS set the build version string to VERS
798	-S	Build a variant of the source product
799		E - build exportable source
800		D - build domestic source (exportable + crypt)
801		H - build hybrid source (binaries + deleted source)
802
803	<env_file>  file in Bourne shell syntax that sets and exports
804	variables that configure the operation of this script and many of
805	the scripts this one calls. If <env_file> does not exist,
806	it will be looked for in $OPTHOME/onbld/env.
807
808non-DEBUG is the default build type. Build options can be set in the
809NIGHTLY_OPTIONS variable in the <env_file> as follows:
810
811	-A	check for ABI differences in .so files
812	-C	check for cstyle/hdrchk errors
813	-D	do a build with DEBUG on
814	-F	do _not_ do a non-DEBUG build
815	-G	gate keeper default group of options (-au)
816	-I	integration engineer default group of options (-ampu)
817	-M	do not run pmodes (safe file permission checker)
818	-N	do not run protocmp
819	-R	default group of options for building a release (-mp)
820	-U	update proto area in the parent
821	-V VERS set the build version string to VERS
822	-X	copy x86 IHV proto area
823	-a	create cpio archives
824	-f	find unreferenced files
825	-i	do an incremental build (no "make clobber")
826	-l	do "make lint" in $LINTDIRS (default: $SRC y)
827	-m	send mail to $MAILTO at end of build
828	-n      do not do a bringover
829	-o	build using root privileges to set OWNER/GROUP (old style)
830	-p	create packages
831	-r	check ELF runtime attributes in the proto area
832	-t	build and use the tools in $SRC/tools
833	-u	update proto_list_$MACH and friends in the parent workspace;
834		when used with -f, also build an unrefmaster.out in the parent
835	-z	compress cpio archives with gzip
836	-W	Do not report warnings (freeware gate ONLY)
837	-S	Build a variant of the source product
838		E - build exportable source
839		D - build domestic source (exportable + crypt)
840		H - build hybrid source (binaries + deleted source)
841'
842#
843#	-x	less public handling of xmod source for the source product
844#
845#	A log file will be generated under the name $LOGFILE
846#	for partially completed build and log.`date '+%F'`
847#	in the same directory for fully completed builds.
848#
849
850# default values for low-level FLAGS; G I R are group FLAGS
851A_FLAG=n
852a_FLAG=n
853C_FLAG=n
854F_FLAG=n
855f_FLAG=n
856D_FLAG=n
857P_FLAG=n
858T_FLAG=n
859n_FLAG=n
860o_FLAG=n
861i_FLAG=n; i_CMD_LINE_FLAG=n
862l_FLAG=n
863m_FLAG=n
864p_FLAG=n
865r_FLAG=n
866t_FLAG=n
867u_FLAG=n
868U_FLAG=n
869V_FLAG=n
870M_FLAG=n
871N_FLAG=n
872z_FLAG=n
873W_FLAG=n
874SE_FLAG=n
875SD_FLAG=n
876SH_FLAG=n
877X_FLAG=n
878#
879XMOD_OPT=
880#
881build_ok=y
882#
883# examine arguments
884#
885
886OPTIND=1
887while getopts inV:S:t FLAG
888do
889	case $FLAG in
890	  i )	i_FLAG=y; i_CMD_LINE_FLAG=y
891		;;
892	  n )	n_FLAG=y
893		;;
894	  V )	V_FLAG=y
895		V_ARG="$OPTARG"
896		;;
897	  S )
898		if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
899			echo "Can only build one source variant at a time."
900			exit 1
901		fi
902		if [ "${OPTARG}" = "E" ]; then
903			SE_FLAG=y
904		elif [ "${OPTARG}" = "D" ]; then
905			SD_FLAG=y
906		elif [ "${OPTARG}" = "H" ]; then
907			SH_FLAG=y
908		else
909			echo "$USAGE"
910			exit 1
911		fi
912		;;
913	  t )	t_FLAG=y
914		;;
915	 \? )	echo "$USAGE"
916		exit 1
917		;;
918	esac
919done
920
921# correct argument count after options
922shift `expr $OPTIND - 1`
923
924# test that the path to the environment-setting file was given
925if [ $# -ne 1 ]; then
926	echo "$USAGE"
927	exit 1
928fi
929
930# check if user is running nightly as root
931# ISUSER is set non-zero if an ordinary user runs nightly, or is zero
932# when root invokes nightly.
933/usr/bin/id | grep '^uid=0(' >/dev/null 2>&1
934ISUSER=$?;	export ISUSER
935
936#
937# force locale to C
938LC_COLLATE=C;	export LC_COLLATE
939LC_CTYPE=C;	export LC_CTYPE
940LC_MESSAGES=C;	export LC_MESSAGES
941LC_MONETARY=C;	export LC_MONETARY
942LC_NUMERIC=C;	export LC_NUMERIC
943LC_TIME=C;	export LC_TIME
944
945# clear environment variables we know to be bad for the build
946unset LD_OPTIONS
947unset LD_AUDIT		LD_AUDIT_32		LD_AUDIT_64
948unset LD_BIND_NOW	LD_BIND_NOW_32		LD_BIND_NOW_64
949unset LD_BREADTH	LD_BREADTH_32		LD_BREADTH_64
950unset LD_CONFIG		LD_CONFIG_32		LD_CONFIG_64
951unset LD_DEBUG		LD_DEBUG_32		LD_DEBUG_64
952unset LD_DEMANGLE	LD_DEMANGLE_32		LD_DEMANGLE_64
953unset LD_FLAGS		LD_FLAGS_32		LD_FLAGS_64
954unset LD_LIBRARY_PATH	LD_LIBRARY_PATH_32	LD_LIBRARY_PATH_64
955unset LD_LOADFLTR	LD_LOADFLTR_32		LD_LOADFLTR_64
956unset LD_NOAUDIT	LD_NOAUDIT_32		LD_NOAUDIT_64
957unset LD_NOAUXFLTR	LD_NOAUXFLTR_32		LD_NOAUXFLTR_64
958unset LD_NOCONFIG	LD_NOCONFIG_32		LD_NOCONFIG_64
959unset LD_NODIRCONFIG	LD_NODIRCONFIG_32	LD_NODIRCONFIG_64
960unset LD_NODIRECT	LD_NODIRECT_32		LD_NODIRECT_64
961unset LD_NOLAZYLOAD	LD_NOLAZYLOAD_32	LD_NOLAZYLOAD_64
962unset LD_NOOBJALTER	LD_NOOBJALTER_32	LD_NOOBJALTER_64
963unset LD_NOVERSION	LD_NOVERSION_32		LD_NOVERSION_64
964unset LD_ORIGIN		LD_ORIGIN_32		LD_ORIGIN_64
965unset LD_PRELOAD	LD_PRELOAD_32		LD_PRELOAD_64
966unset LD_PROFILE	LD_PROFILE_32		LD_PROFILE_64
967
968unset CONFIG
969unset GROUP
970unset OWNER
971unset REMOTE
972unset ENV
973unset ARCH
974unset CLASSPATH
975unset NAME
976
977#
978#	Setup environmental variables
979#
980if [ -f $1 ]; then
981	if [[ $1 = */* ]]; then
982		. $1
983	else
984		. ./$1
985	fi
986else
987	if [ -f $OPTHOME/onbld/env/$1 ]; then
988		. $OPTHOME/onbld/env/$1
989	else
990		echo "Cannot find env file as either $1 or $OPTHOME/onbld/env/$1"
991		exit 1
992	fi
993fi
994
995#
996# place ourselves in a new task, respecting BUILD_PROJECT if set.
997#
998if [ -z "$BUILD_PROJECT" ]; then
999	/usr/bin/newtask -c $$
1000else
1001	/usr/bin/newtask -c $$ -p $BUILD_PROJECT
1002fi
1003
1004ps -o taskid= -p $$ | read build_taskid
1005ps -o project= -p $$ | read build_project
1006
1007#
1008# See if NIGHTLY_OPTIONS is set
1009#
1010if [ "$NIGHTLY_OPTIONS" = "" ]; then
1011	NIGHTLY_OPTIONS="-aBm"
1012fi
1013
1014#
1015# If BRINGOVER_WS was not specified, let it default to CLONE_WS
1016#
1017if [ "$BRINGOVER_WS" = "" ]; then
1018	BRINGOVER_WS=$CLONE_WS
1019fi
1020
1021#
1022# If BRINGOVER_FILES was not specified, default to usr
1023#
1024if [ "$BRINGOVER_FILES" = "" ]; then
1025	BRINGOVER_FILES="usr"
1026fi
1027
1028#
1029# If the closed sources are not present, the closed binaries must be
1030# present for the build to succeed.  If there's no pointer to the
1031# closed binaries, flag that now, rather than forcing the user to wait
1032# a couple hours (or more) to find out.
1033#
1034orig_closed_is_present="$CLOSED_IS_PRESENT"
1035check_closed_tree
1036
1037#
1038# Note: changes to the option letters here should also be applied to the
1039#	bldenv script.  `d' is listed for backward compatibility.
1040#
1041NIGHTLY_OPTIONS=-${NIGHTLY_OPTIONS#-}
1042OPTIND=1
1043while getopts ABDFNMPTCGIRafinlmoptuUxdrtzWS:X FLAG $NIGHTLY_OPTIONS
1044do
1045	case $FLAG in
1046	  A )	A_FLAG=y
1047		;;
1048	  B )	D_FLAG=y
1049		;; # old version of D
1050	  F )	F_FLAG=y
1051		;;
1052	  D )	D_FLAG=y
1053		;;
1054	  P )	P_FLAG=y
1055		;; # obsolete
1056	  T )	T_FLAG=y
1057		;; # obsolete
1058	  C )	C_FLAG=y
1059		;;
1060	  M )	M_FLAG=y
1061		;;
1062	  N )	N_FLAG=y
1063		;;
1064	  G )	a_FLAG=y
1065		u_FLAG=y
1066		;;
1067	  I )	a_FLAG=y
1068		m_FLAG=y
1069		p_FLAG=y
1070		u_FLAG=y
1071		;;
1072	  R )	m_FLAG=y
1073		p_FLAG=y
1074		;;
1075	  a )	a_FLAG=y
1076		;;
1077	  f )	f_FLAG=y
1078		;;
1079	  i )	i_FLAG=y
1080		;;
1081	  n )	n_FLAG=y
1082		;;
1083	  o )	o_FLAG=y
1084		;;
1085	  l )	l_FLAG=y
1086		;;
1087	  m )	m_FLAG=y
1088		;;
1089	  p )	p_FLAG=y
1090		;;
1091	  r )	r_FLAG=y
1092		;;
1093	  t )	t_FLAG=y
1094		;;
1095	  u )	u_FLAG=y
1096		;;
1097	  z )	z_FLAG=y
1098		;;
1099	  U )
1100		if [ -z "${PARENT_ROOT}" ]; then
1101			echo "PARENT_ROOT must be set if the U flag is" \
1102			    "present in NIGHTLY_OPTIONS."
1103			exit 1
1104		fi
1105		U_FLAG=y
1106		NIGHTLY_PARENT_ROOT=$PARENT_ROOT
1107		;;
1108	  x )	XMOD_OPT="-x"
1109		;;
1110	  W )	W_FLAG=y
1111		;;
1112	  S )
1113		if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
1114			echo "Can only build one source variant at a time."
1115			exit 1
1116		fi
1117		if [ "${OPTARG}" = "E" ]; then
1118			SE_FLAG=y
1119		elif [ "${OPTARG}" = "D" ]; then
1120			SD_FLAG=y
1121		elif [ "${OPTARG}" = "H" ]; then
1122			SH_FLAG=y
1123		else
1124			echo "$USAGE"
1125			exit 1
1126		fi
1127		;;
1128	  X )	# now that we no longer need realmode builds, just
1129		# copy IHV packages.  only meaningful on x86.
1130		if [ "$MACH" = "i386" ]; then
1131			X_FLAG=y
1132		fi
1133		;;
1134	 \? )	echo "$USAGE"
1135		exit 1
1136		;;
1137	esac
1138done
1139
1140if [ $ISUSER -ne 0 ]; then
1141	if [ "$o_FLAG" = "y" ]; then
1142		echo "Old-style build requires root permission."
1143		exit 1
1144	fi
1145
1146	# Set default value for STAFFER, if needed.
1147	if [ -z "$STAFFER" -o "$STAFFER" = "nobody" ]; then
1148		STAFFER=`/usr/xpg4/bin/id -un`
1149		export STAFFER
1150	fi
1151fi
1152
1153if [ -z "$MAILTO" -o "$MAILTO" = "nobody" ]; then
1154	MAILTO=$STAFFER
1155	export MAILTO
1156fi
1157
1158PATH="$OPTHOME/onbld/bin:$OPTHOME/onbld/bin/${MACH}:/usr/ccs/bin"
1159PATH="$PATH:$OPTHOME/SUNWspro/bin:$TEAMWARE/bin:/usr/bin:/usr/sbin:/usr/ucb"
1160PATH="$PATH:/usr/openwin/bin:/usr/sfw/bin:/opt/sfw/bin:."
1161export PATH
1162
1163# roots of source trees, both relative to $SRC and absolute.
1164relsrcdirs="."
1165if [[ -d $SRC/../closed && "$CLOSED_IS_PRESENT" != no ]]; then
1166	relsrcdirs="$relsrcdirs ../closed"
1167fi
1168abssrcdirs=""
1169for d in $relsrcdirs; do
1170	abssrcdirs="$abssrcdirs $SRC/$d"
1171done
1172
1173unset CH
1174if [ "$o_FLAG" = "y" ]; then
1175# root invoked old-style build -- make sure it works as it always has
1176# by exporting 'CH'.  The current Makefile.master doesn't use this, but
1177# the old ones still do.
1178	PROTOCMPTERSE="protocmp.terse"
1179	CH=
1180	export CH
1181else
1182	PROTOCMPTERSE="protocmp.terse -gu"
1183fi
1184POUND_SIGN="#"
1185
1186# we export POUND_SIGN to speed up the build process -- prevents evaluation of
1187# the Makefile.master definitions.
1188export o_FLAG POUND_SIGN
1189
1190maketype="distributed"
1191MAKE=dmake
1192# get the dmake version string alone
1193DMAKE_VERSION=$( $MAKE -v )
1194DMAKE_VERSION=${DMAKE_VERSION#*: }
1195# focus in on just the dotted version number alone
1196DMAKE_MAJOR=$( echo $DMAKE_VERSION | \
1197	sed -e 's/.*\<\([^.]*\.[^   ]*\).*$/\1/' )
1198# extract the second (or final) integer
1199DMAKE_MINOR=${DMAKE_MAJOR#*.}
1200DMAKE_MINOR=${DMAKE_MINOR%%.*}
1201# extract the first integer
1202DMAKE_MAJOR=${DMAKE_MAJOR%%.*}
1203CHECK_DMAKE=${CHECK_DMAKE:-y}
1204# x86 was built on the 12th, sparc on the 13th.
1205if [ "$CHECK_DMAKE" = "y" -a \
1206     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/12" -a \
1207     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/13" -a \( \
1208     "$DMAKE_MAJOR" -lt 7 -o \
1209     "$DMAKE_MAJOR" -eq 7 -a "$DMAKE_MINOR" -lt 4 \) ]; then
1210	if [ -z "$DMAKE_VERSION" ]; then
1211		echo "$MAKE is missing."
1212		exit 1
1213	fi
1214	echo `whence $MAKE`" version is:"
1215	echo "  ${DMAKE_VERSION}"
1216	cat <<EOF
1217
1218This version may not be safe for use.  Either set TEAMWARE to a better
1219path or (if you really want to use this version of dmake anyway), add
1220the following to your environment to disable this check:
1221
1222  CHECK_DMAKE=n
1223EOF
1224	exit 1
1225fi
1226export PATH
1227export MAKE
1228
1229if [ "${SUNWSPRO}" != "" ]; then
1230	PATH="${SUNWSPRO}/bin:$PATH"
1231	export PATH
1232fi
1233
1234hostname=`uname -n`
1235if [ ! -f $HOME/.make.machines ]; then
1236	DMAKE_MAX_JOBS=4
1237else
1238	DMAKE_MAX_JOBS="`grep $hostname $HOME/.make.machines | \
1239	    tail -1 | awk -F= '{print $ 2;}'`"
1240	if [ "$DMAKE_MAX_JOBS" = "" ]; then
1241		DMAKE_MAX_JOBS=4
1242	fi
1243fi
1244DMAKE_MODE=parallel;
1245export DMAKE_MODE
1246export DMAKE_MAX_JOBS
1247
1248if [ -z "${ROOT}" ]; then
1249	echo "ROOT must be set."
1250	exit 1
1251fi
1252
1253if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" ]; then
1254        if [ -z "${EXPORT_SRC}" ]; then
1255		echo "EXPORT_SRC must be set for a source build."
1256		exit 1
1257	fi
1258        if [ -z "${CRYPT_SRC}" ]; then
1259		echo "CRYPT_SRC must be set for a source build."
1260		exit 1
1261	fi
1262fi
1263
1264if [ "$SH_FLAG" = "y" ]; then
1265        if [ -z "${EXPORT_SRC}" ]; then
1266		echo "EXPORT_SRC must be set for a source build."
1267		exit 1
1268	fi
1269fi
1270
1271#
1272# if -V flag was given, reset VERSION to V_ARG
1273#
1274if [ "$V_FLAG" = "y" ]; then
1275	VERSION=$V_ARG
1276fi
1277
1278#
1279# Check for IHV root for copying ihv proto area
1280#
1281if [ "$X_FLAG" = "y" ]; then
1282        if [ "$IA32_IHV_ROOT" = "" ]; then
1283		echo "IA32_IHV_ROOT: must be set for copying ihv proto"
1284		args_ok=n
1285        fi
1286        if [ ! -d "$IA32_IHV_ROOT" ]; then
1287                echo "$IA32_IHV_ROOT: not found"
1288                args_ok=n
1289        fi
1290fi
1291
1292# Append source version
1293if [ "$SE_FLAG" = "y" ]; then
1294	VERSION="${VERSION}:EXPORT"
1295fi
1296
1297if [ "$SD_FLAG" = "y" ]; then
1298	VERSION="${VERSION}:DOMESTIC"
1299fi
1300
1301if [ "$SH_FLAG" = "y" ]; then
1302	VERSION="${VERSION}:MODIFIED_SOURCE_PRODUCT"
1303fi
1304
1305TMPDIR="/tmp/nightly.tmpdir.$$"
1306export TMPDIR
1307rm -rf ${TMPDIR}
1308mkdir -p $TMPDIR || exit 1
1309
1310#
1311# Keep elfsign's use of pkcs11_softtoken from looking in the user home
1312# directory, which doesn't always work.   Needed until all build machines
1313# have the fix for 6271754
1314#
1315SOFTTOKEN_DIR=$TMPDIR
1316export SOFTTOKEN_DIR
1317
1318TOOLS=${SRC}/tools
1319TOOLS_PROTO=${TOOLS}/proto
1320
1321unset   CFLAGS LD_LIBRARY_PATH LDFLAGS
1322
1323# create directories that are automatically removed if the nightly script
1324# fails to start correctly
1325newdir() {
1326	dir=$1
1327	toadd=
1328	while [ ! -d $dir ]; do
1329		toadd="$dir $toadd"
1330		dir=`dirname $dir`
1331	done
1332	torm=
1333	newlist=
1334	for dir in $toadd; do
1335		if staffer mkdir $dir; then
1336			newlist="$ISUSER $dir $newlist"
1337			torm="$dir $torm"
1338		else
1339			[ -z "$torm" ] || staffer rmdir $torm
1340			return 1
1341		fi
1342	done
1343	newdirlist="$newlist $newdirlist"
1344	return 0
1345}
1346newdirlist=
1347
1348[ -d $CODEMGR_WS ] || newdir $CODEMGR_WS || exit 1
1349
1350# since this script assumes the build is from full source, it nullifies
1351# variables likely to have been set by a "ws" script; nullification
1352# confines the search space for headers and libraries to the proto area
1353# built from this immediate source.
1354ENVLDLIBS1=
1355ENVLDLIBS2=
1356ENVLDLIBS3=
1357ENVCPPFLAGS1=
1358ENVCPPFLAGS2=
1359ENVCPPFLAGS3=
1360ENVCPPFLAGS4=
1361PARENT_ROOT=
1362
1363export ENVLDLIBS3 ENVCPPFLAGS1 ENVCPPFLAGS2 ENVCPPFLAGS3 ENVCPPFLAGS4 \
1364	PARENT_ROOT
1365
1366ENVLDLIBS1="-L$ROOT/lib -L$ROOT/usr/lib"
1367ENVCPPFLAGS1="-I$ROOT/usr/include"
1368
1369export ENVLDLIBS1 ENVLDLIBS2
1370
1371CPIODIR_ORIG=$CPIODIR
1372PKGARCHIVE_ORIG=$PKGARCHIVE
1373IA32_IHV_PKGS_ORIG=$IA32_IHV_PKGS
1374if [ "$SPARC_RM_PKGARCHIVE" ]; then
1375	SPARC_RM_PKGARCHIVE_ORIG=$SPARC_RM_PKGARCHIVE
1376fi
1377
1378#
1379# Juggle the logs and optionally send mail on completion.
1380#
1381
1382logshuffle() {
1383    	LLOG="$ATLOG/log.`date '+%F'`"
1384	rm -rf $ATLOG/log.??`date '+%d'`
1385	rm -rf $ATLOG/log.????-??-`date '+%d'`
1386	if [ -f $LLOG -o -d $LLOG ]; then
1387	    	LLOG=$LLOG.$$
1388	fi
1389	mkdir $LLOG
1390
1391	if [ "$build_ok" = "y" ]; then
1392		mv $ATLOG/proto_list_${MACH} $LLOG
1393	fi
1394
1395	#
1396	# Now that we're about to send mail, it's time to check the noise
1397	# file.  In the event that an error occurs beyond this point, it will
1398	# be recorded in the nightly.log file, but nowhere else.  This would
1399	# include only errors that cause the copying of the noise log to fail
1400	# or the mail itself not to be sent.
1401	#
1402
1403	exec >>$LOGFILE 2>&1
1404	if [ -s $build_noise_file ]; then
1405	    	echo "\n==== Nightly build noise ====\n" |
1406		    tee -a $LOGFILE >>$mail_msg_file
1407		cat $build_noise_file >>$LOGFILE
1408		cat $build_noise_file >>$mail_msg_file
1409		echo | tee -a $LOGFILE >>$mail_msg_file
1410	fi
1411	rm -f $build_noise_file
1412
1413	case "$build_ok" in
1414		y)
1415			state=Completed
1416			;;
1417		i)
1418			state=Interrupted
1419			;;
1420		*)
1421	    		state=Failed
1422			;;
1423	esac
1424
1425	cat $build_time_file $mail_msg_file > ${LLOG}/mail_msg
1426	if [ "$m_FLAG" = "y" ]; then
1427	    	cat $build_time_file $mail_msg_file |
1428		    /usr/bin/mailx -s \
1429	"Nightly ${MACH} Build of `basename ${CODEMGR_WS}` ${state}." \
1430			${MAILTO}
1431	fi
1432
1433	if [ "$u_FLAG" = "y" -a "$build_ok" = "y" ]; then
1434	    	staffer cp ${LLOG}/mail_msg $PARENT_WS/usr/src/mail_msg-${MACH}
1435		staffer cp $LOGFILE $PARENT_WS/usr/src/nightly-${MACH}.log
1436	fi
1437
1438	mv $LOGFILE $LLOG
1439}
1440
1441#
1442#	Remove the locks and temporary files on any exit
1443#
1444cleanup() {
1445    	logshuffle
1446
1447	[ -z "$lockfile" ] || staffer rm -f $lockfile
1448	[ -z "$atloglockfile" ] || rm -f $atloglockfile
1449	[ -z "$ulockfile" ] || staffer rm -f $ulockfile
1450	[ -z "$Ulockfile" ] || rm -f $Ulockfile
1451
1452	set -- $newdirlist
1453	while [ $# -gt 0 ]; do
1454		ISUSER=$1 staffer rmdir $2
1455		shift; shift
1456	done
1457	rm -rf $TMPDIR
1458}
1459
1460cleanup_signal() {
1461    	build_ok=i
1462	# this will trigger cleanup(), above.
1463	exit 1
1464}
1465
1466trap cleanup 0
1467trap cleanup_signal 1 2 3 15
1468
1469#
1470# Generic lock file processing -- make sure that the lock file doesn't
1471# exist.  If it does, it should name the build host and PID.  If it
1472# doesn't, then make sure we can create it.  Clean up locks that are
1473# known to be stale (assumes host name is unique among build systems
1474# for the workspace).
1475create_lock() {
1476	lockf=$1
1477	lockvar=$2
1478	if [ -f $lockf ]; then
1479		basews=`basename $CODEMGR_WS`
1480		if read host user pid < $lockf; then
1481			if [ "$host" != "$hostname" ]; then
1482				echo "$MACH build of $basews apparently" \
1483				    "already started by $user on $host as $pid."
1484			elif kill -s 0 $pid 2>/dev/null; then
1485				echo "$MACH build of $basews already started" \
1486				    "by $user as $pid."
1487			else
1488				# stale lock; clear it out and continue
1489				rm -f $lockf
1490			fi
1491		else
1492			echo "$MACH build of $basews already running."
1493		fi
1494	fi
1495	if [ -f $lockf ]; then
1496		echo "Lock file is $lockf."
1497		exit 1
1498	fi
1499	ldir=`dirname $lockf`
1500	[ -d $ldir ] || newdir $ldir || exit 1
1501	eval $lockvar=$lockf
1502	staffer sh -c "echo $hostname $STAFFER $$ > $lockf" || exit 1
1503}
1504
1505# Ensure no other instance of this script is running on this host.
1506# LOCKNAME can be set in <env_file>, and is by default, but is not
1507# required due to the use of $ATLOG below.
1508if [ -n "$LOCKNAME" ]; then
1509	create_lock /tmp/$LOCKNAME "lockfile"
1510fi
1511#
1512# Create from one, two, or three other locks:
1513#	$ATLOG/nightly.lock
1514#		- protects against multiple builds in same workspace
1515#	$PARENT_WS/usr/src/nightly.$MACH.lock
1516#		- protects against multiple 'u' copy-backs
1517#	$NIGHTLY_PARENT_ROOT/nightly.lock
1518#		- protects against multiple 'U' copy-backs
1519#
1520# Overriding ISUSER to 1 causes the lock to be created as root if the
1521# script is run as root.  The default is to create it as $STAFFER.
1522ISUSER=1 create_lock $ATLOG/nightly.lock "atloglockfile"
1523if [ "$u_FLAG" = "y" ]; then
1524	create_lock $PARENT_WS/usr/src/nightly.$MACH.lock "ulockfile"
1525fi
1526if [ "$U_FLAG" = "y" ]; then
1527	# NIGHTLY_PARENT_ROOT is written as root if script invoked as root.
1528	ISUSER=1 create_lock $NIGHTLY_PARENT_ROOT/nightly.lock "Ulockfile"
1529fi
1530
1531# Locks have been taken, so we're doing a build and we're committed to
1532# the directories we may have created so far.
1533newdirlist=
1534
1535#
1536# Create mail_msg_file
1537#
1538mail_msg_file="${TMPDIR}/mail_msg"
1539touch $mail_msg_file
1540build_time_file="${TMPDIR}/build_time"
1541#
1542#	Move old LOGFILE aside
1543#	ATLOG directory already made by 'create_lock' above
1544#
1545if [ -f $LOGFILE ]; then
1546	mv -f $LOGFILE ${LOGFILE}-
1547fi
1548#
1549#	Build OsNet source
1550#
1551START_DATE=`date`
1552SECONDS=0
1553echo "\n==== Nightly $maketype build started:   $START_DATE ====" \
1554    | tee -a $LOGFILE > $build_time_file
1555
1556# make sure we log only to the nightly build file
1557build_noise_file="${TMPDIR}/build_noise"
1558exec </dev/null >$build_noise_file 2>&1
1559
1560echo "\n==== list of environment variables ====\n" >> $LOGFILE
1561env >> $LOGFILE
1562
1563echo "\n==== Nightly argument issues ====\n" | tee -a $mail_msg_file >> $LOGFILE
1564
1565if [ "$P_FLAG" = "y" ]; then
1566	obsolete_build GPROF | tee -a $mail_msg_file >> $LOGFILE
1567fi
1568
1569if [ "$T_FLAG" = "y" ]; then
1570	obsolete_build TRACE | tee -a $mail_msg_file >> $LOGFILE
1571fi
1572
1573if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
1574	if [ "$i_FLAG" = "y" -o "$i_CMD_LINE_FLAG" = "y" ]; then
1575		echo "WARNING: the -S flags do not support incremental" \
1576		    "builds; forcing clobber\n" | tee -a $mail_msg_file >> $LOGFILE
1577		i_FLAG=n
1578		i_CMD_LINE_FLAG=n
1579	fi
1580	if [ "$N_FLAG" = "n" ]; then
1581		echo "WARNING: the -S flags do not support protocmp;" \
1582		    "protocmp disabled\n" | \
1583		    tee -a $mail_msg_file >> $LOGFILE
1584		N_FLAG=y
1585	fi
1586	if [ "$l_FLAG" = "y" ]; then
1587		echo "WARNING: the -S flags do not support lint;" \
1588		    "lint disabled\n" | tee -a $mail_msg_file >> $LOGFILE
1589		l_FLAG=n
1590	fi
1591	if [ "$C_FLAG" = "y" ]; then
1592		echo "WARNING: the -S flags do not support cstyle;" \
1593		    "cstyle check disabled\n" | tee -a $mail_msg_file >> $LOGFILE
1594		C_FLAG=n
1595	fi
1596else
1597	if [ "$N_FLAG" = "y" ]; then
1598		if [ "$p_FLAG" = "y" ]; then
1599			cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1600WARNING: the p option (create packages) is set, but so is the N option (do
1601         not run protocmp); this is dangerous; you should unset the N option
1602EOF
1603		else
1604			cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1605Warning: the N option (do not run protocmp) is set; it probably shouldn't be
1606EOF
1607		fi
1608		echo "" | tee -a $mail_msg_file >> $LOGFILE
1609	fi
1610fi
1611
1612if [ "$a_FLAG" = "y" -a "$D_FLAG" = "n" -a "$F_FLAG" = "y" ]; then
1613	echo "WARNING: Neither DEBUG nor non-DEBUG build requested, but the" \
1614	    "'a' option was set." | tee -a $mail_msg_file >> $LOGFILE
1615fi
1616
1617if [ "$D_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
1618	echo "WARNING: DEBUG build not requested, but lint will be with" \
1619	    "DEBUG enabled.\n" \
1620	    | tee -a $mail_msg_file >> $LOGFILE
1621fi
1622
1623if [ "$f_FLAG" = "y" ]; then
1624	if [ "$i_FLAG" = "y" ]; then
1625		echo "WARNING: the -f flag cannot be used during incremental" \
1626		    "builds; ignoring -f\n" | tee -a $mail_msg_file >> $LOGFILE
1627		f_FLAG=n
1628	fi
1629	if [ "$p_FLAG" != "y" -o "$l_FLAG" != "y" ]; then
1630		echo "WARNING: the -f flag requires -l and -p; ignoring -f\n" | \
1631		    tee -a $mail_msg_file >> $LOGFILE
1632		f_FLAG=n
1633	fi
1634fi
1635
1636if [ "$t_FLAG" = "n" ]; then
1637	#
1638	# We're not doing a tools build, so make sure elfsign(1) is
1639	# new enough to safely sign non-crypto binaries.  We test
1640	# debugging output from elfsign to detect the old version.
1641	#
1642	newelfsigntest=`SUNW_CRYPTO_DEBUG=stderr /usr/bin/elfsign verify \
1643	    -e /usr/lib/security/pkcs11_softtoken.so.1 2>&1 \
1644	    | egrep algorithmOID`
1645	if [ -z "$newelfsigntest" ]; then
1646		echo "WARNING: /usr/bin/elfsign out of date;" \
1647		    "will only sign crypto modules\n" | \
1648		    tee -a $mail_msg_file >> $LOGFILE
1649		export ELFSIGN_OBJECT=true
1650	elif [ "$VERIFY_ELFSIGN" = "y" ]; then
1651		echo "WARNING: VERIFY_ELFSIGN=y requires" \
1652		    "the -t flag; ignoring VERIFY_ELFSIGN\n" | \
1653		    tee -a $mail_msg_file >> $LOGFILE
1654	fi
1655fi
1656
1657# copy ihv proto area in addition to the build itself
1658
1659if [ "$X_FLAG" = "y" ]; then
1660
1661	# Install IA32 IHV proto area
1662	copy_ihv_proto
1663fi
1664
1665echo "==== Build environment ====\n" | tee -a $mail_msg_file >> $LOGFILE
1666
1667# System
1668whence uname | tee -a $mail_msg_file >> $LOGFILE
1669uname -a 2>&1 | tee -a $mail_msg_file >> $LOGFILE
1670echo | tee -a $mail_msg_file >> $LOGFILE
1671
1672# nightly (will fail in year 2100 due to SCCS flaw)
1673echo "$0 $@" | tee -a $mail_msg_file >> $LOGFILE
1674echo "%M% version %I% 20%E%\n" | tee -a $mail_msg_file >> $LOGFILE
1675
1676# make
1677whence $MAKE | tee -a $mail_msg_file >> $LOGFILE
1678$MAKE -v | tee -a $mail_msg_file >> $LOGFILE
1679echo "number of concurrent jobs = $DMAKE_MAX_JOBS" |
1680    tee -a $mail_msg_file >> $LOGFILE
1681
1682#
1683# Report the compiler versions.
1684#
1685if [ -f $SRC/Makefile ]; then
1686	srcroot=$SRC
1687elif [ -f $BRINGOVER_WS/usr/src/Makefile ]; then
1688	srcroot=$BRINGOVER_WS/usr/src
1689else
1690	echo "\nUnable to find \"Makefile\" in $BRINGOVER_WS/usr/src or $SRC." |
1691	    tee -a $mail_msg_file >> $LOGFILE
1692	exit 1
1693fi
1694
1695( cd $srcroot
1696  for target in cc-version cc64-version java-version; do
1697	echo
1698	#
1699	# Put statefile somewhere we know we can write to rather than trip
1700	# over a read-only $srcroot.
1701	#
1702	rm -f $TMPDIR/make-state
1703	export SRC=$srcroot
1704	if $MAKE -K $TMPDIR/make-state -e $target 2>/dev/null; then
1705		continue
1706	fi
1707	touch $TMPDIR/nocompiler
1708  done
1709  echo
1710) | tee -a $mail_msg_file >> $LOGFILE
1711
1712if [ -f $TMPDIR/nocompiler ]; then
1713	rm -f $TMPDIR/nocompiler
1714	build_ok=n
1715	echo "Aborting due to missing compiler." |
1716		tee -a $mail_msg_file >> $LOGFILE
1717	exit 1
1718fi
1719
1720# as
1721whence as | tee -a $mail_msg_file >> $LOGFILE
1722as -V 2>&1 | head -1 | tee -a $mail_msg_file >> $LOGFILE
1723echo | tee -a $mail_msg_file >> $LOGFILE
1724
1725# Check that we're running a capable link-editor
1726whence ld | tee -a $mail_msg_file >> $LOGFILE
1727LDVER=`ld -V 2>&1`
1728echo $LDVER | tee -a $mail_msg_file >> $LOGFILE
1729LDVER=`echo $LDVER | sed -e "s/.*-1\.//" -e "s/:.*//"`
1730if [ `expr $LDVER \< 422` -eq 1 ]; then
1731	echo "The link-editor needs to be at version 422 or higher to build" | \
1732	    tee -a $mail_msg_file >> $LOGFILE
1733	echo "the latest stuff, hope your build works." | \
1734	    tee -a $mail_msg_file >> $LOGFILE
1735fi
1736
1737echo "\nBuild project:  $build_project\nBuild taskid:   $build_taskid" | \
1738    tee -a $mail_msg_file >> $LOGFILE
1739
1740echo "\n==== Build version ====\n" | tee -a $mail_msg_file >> $LOGFILE
1741echo $VERSION | tee -a $mail_msg_file >> $LOGFILE
1742
1743#
1744#	Decide whether to clobber
1745#
1746if [ "$i_FLAG" = "n" -a -d "$SRC" ]; then
1747	echo "\n==== Make clobber at `date` ====\n" >> $LOGFILE
1748
1749	cd $SRC
1750	# remove old clobber file
1751	rm -f $SRC/clobber.out
1752	rm -f $SRC/clobber-${MACH}.out
1753
1754	# Remove all .make.state* files, just in case we are restarting
1755	# the build after having interrupted a previous 'make clobber'.
1756	find . \( -name SCCS -o -name 'interfaces.*' \) -prune \
1757	    -o -name '.make.*' -print | xargs rm -f
1758
1759	$MAKE -ek clobber 2>&1 | tee -a $SRC/clobber-${MACH}.out >> $LOGFILE
1760	echo "\n==== Make clobber ERRORS ====\n" >> $mail_msg_file
1761	grep "$MAKE:" $SRC/clobber-${MACH}.out |
1762		egrep -v "Ignoring unknown host" \
1763		>> $mail_msg_file
1764
1765	if [ "$t_FLAG" = "y" ]; then
1766		echo "\n==== Make tools clobber at `date` ====\n" >> $LOGFILE
1767		cd ${TOOLS}
1768		rm -f ${TOOLS}/clobber-${MACH}.out
1769		$MAKE -ek clobber 2>&1 | \
1770			tee -a ${TOOLS}/clobber-${MACH}.out >> $LOGFILE
1771		echo "\n==== Make tools clobber ERRORS ====\n" \
1772			>> $mail_msg_file
1773		grep "$MAKE:" ${TOOLS}/clobber-${MACH}.out \
1774			>> $mail_msg_file
1775		rm -rf ${TOOLS_PROTO}
1776		mkdir -p ${TOOLS_PROTO}
1777	fi
1778	rm -rf $ROOT
1779
1780	# Get back to a clean workspace as much as possible to catch
1781	# problems that only occur on fresh workspaces.
1782	# Remove all .make.state* files, libraries, and .o's that may
1783	# have been omitted from clobber.  A couple of libraries are
1784	# under SCCS, so leave them alone.
1785	# We should probably blow away temporary directories too.
1786	cd $SRC
1787	find $relsrcdirs \( -name SCCS -o -name 'interfaces.*' \) -prune -o \
1788	    \( -name '.make.*' -o -name 'lib*.a' -o -name 'lib*.so*' -o \
1789	       -name '*.o' \) -print | \
1790	    grep -v 'tools/ctf/dwarf/.*/libdwarf' | xargs rm -f
1791else
1792	echo "\n==== No clobber at `date` ====\n" >> $LOGFILE
1793fi
1794
1795#
1796#	Decide whether to bringover to the codemgr workspace
1797#
1798if [ "$n_FLAG" = "n" ]; then
1799	echo "\n==== bringover to $CODEMGR_WS at `date` ====\n" >> $LOGFILE
1800	# sleep on the parent workspace's lock
1801	while egrep -s write $BRINGOVER_WS/Codemgr_wsdata/locks
1802	do
1803		sleep 120
1804	done
1805
1806	echo "\n==== BRINGOVER LOG ====\n" >> $mail_msg_file
1807
1808	(staffer $TEAMWARE/bin/bringover -c "nightly update" -p $BRINGOVER_WS \
1809	    -w $CODEMGR_WS $BRINGOVER_FILES < /dev/null 2>&1 ||
1810		touch $TMPDIR/bringover_failed
1811
1812         staffer bringovercheck $CODEMGR_WS >$TMPDIR/bringovercheck.out 2>&1
1813
1814	 if [ -s $TMPDIR/bringovercheck.out ]; then
1815		echo "\n==== POST-BRINGOVER CLEANUP NOISE ====\n"
1816		cat $TMPDIR/bringovercheck.out
1817	 fi
1818
1819	) | tee -a  $mail_msg_file >> $LOGFILE
1820
1821	if [ -f $TMPDIR/bringover_failed ]; then
1822		rm -f $TMPDIR/bringover_failed
1823		build_ok=n
1824		echo "trouble with bringover, quitting at `date`." |
1825			tee -a $mail_msg_file >> $LOGFILE
1826		exit 1
1827	fi
1828
1829	#
1830	# Possible transition from pre-split workspace to split
1831	# workspace.  See if the bringover changed anything.
1832	#
1833	CLOSED_IS_PRESENT="$orig_closed_is_present"
1834	check_closed_tree
1835else
1836	echo "\n==== No bringover to $CODEMGR_WS ====\n" >> $LOGFILE
1837fi
1838
1839#
1840# Build tools if requested
1841#
1842if [ "$t_FLAG" = "y" ]; then
1843	export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
1844	export RELEASE_BUILD ; RELEASE_BUILD=
1845	unset EXTRA_OPTIONS
1846	unset EXTRA_CFLAGS
1847
1848	export ONBLD_TOOLS=${ONBLD_TOOLS:=${TOOLS_PROTO}/opt/onbld}
1849	build_tools ${TOOLS_PROTO}
1850fi
1851
1852if [ "$i_FLAG" = "y" -a "$SH_FLAG" = "y" ]; then
1853	echo "\n==== NOT Building base OS-Net source ====\n" | \
1854	    tee -a $LOGFILE >> $mail_msg_file
1855else
1856	normal_build
1857fi
1858
1859ORIG_SRC=$SRC
1860BINARCHIVE=${CODEMGR_WS}/bin-${MACH}.cpio.Z
1861
1862if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
1863	save_binaries
1864
1865	echo "\n==== Retrieving SCCS files at `date` ====\n" >> $LOGFILE
1866	SCCSHELPER=${TMPDIR}/sccs-helper
1867	rm -f ${SCCSHELPER}
1868cat >${SCCSHELPER} <<EOF
1869#!/bin/ksh
1870cd \$1
1871cd ..
1872sccs get SCCS >/dev/null 2>&1
1873EOF
1874	cd $SRC
1875	chmod +x ${SCCSHELPER}
1876	find $relsrcdirs -name SCCS | xargs -L 1 ${SCCSHELPER}
1877	rm -f ${SCCSHELPER}
1878fi
1879
1880if [ "$SD_FLAG" = "y" ]; then
1881	clone_source ${CODEMGR_WS} ${CRYPT_SRC} CRYPT_SRC
1882fi
1883
1884# EXPORT_SRC comes after CRYPT_SRC since a domestic build will need
1885# $SRC pointing to the export_source usr/src.
1886if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
1887	clone_source ${CODEMGR_WS} ${EXPORT_SRC} EXPORT_SRC
1888fi
1889
1890if [ "$SD_FLAG" = "y" ]; then
1891	# drop the crypt files in place.
1892	cd ${EXPORT_SRC}
1893	echo "\nextracting crypt_files.cpio.Z onto export_source.\n" \
1894	    >> ${LOGFILE}
1895	zcat ${CODEMGR_WS}/crypt_files.cpio.Z | \
1896	    cpio -idmucvB 2>/dev/null >> ${LOGFILE}
1897	if [ "$?" = "0" ]; then
1898		echo "\n==== DOMESTIC extraction succeeded ====\n" \
1899		    >> $mail_msg_file
1900	else
1901		echo "\n==== DOMESTIC extraction failed ====\n" \
1902		    >> $mail_msg_file
1903	fi
1904
1905fi
1906
1907if [ "$SE_FLAG" = "y" -o "$SD_FLAG" = "y" -o "$SH_FLAG" = "y" ]; then
1908	# remove proto area here, since we don't clobber
1909	rm -rf "$ROOT"
1910	if [ "$t_FLAG" = "y" ]; then
1911		export INTERNAL_RELEASE_BUILD ; INTERNAL_RELEASE_BUILD=
1912		export RELEASE_BUILD ; RELEASE_BUILD=
1913		unset EXTRA_OPTIONS
1914		unset EXTRA_CFLAGS
1915		ORIG_TOOLS=$TOOLS
1916		TOOLS=${EXPORT_SRC}/usr/src/tools
1917		build_tools ${EXPORT_SRC}/usr/src/tools/proto
1918		TOOLS=$ORIG_TOOLS
1919	fi
1920
1921	export EXPORT_RELEASE_BUILD ; EXPORT_RELEASE_BUILD=#
1922	normal_build
1923fi
1924
1925if [ "$build_ok" = "y" ]; then
1926	echo "\n==== Creating protolist system file at `date` ====" \
1927		>> $LOGFILE
1928	protolist $ROOT > $ATLOG/proto_list_${MACH}
1929	echo "==== protolist system file created at `date` ====\n" \
1930		>> $LOGFILE
1931
1932	if [ "$N_FLAG" != "y" ]; then
1933		echo "\n==== Impact on packages ====\n" >> $mail_msg_file
1934
1935		# If there is a reference proto list, compare the build's proto
1936		# list with the reference to see changes in proto areas.
1937		# Use the current exception list.
1938		exc=etc/exception_list_$MACH
1939		if [ -f $SRC/pkgdefs/$exc ]; then
1940			ELIST="-e $SRC/pkgdefs/$exc"
1941		fi
1942
1943		if [ -f "$REF_PROTO_LIST" ]; then
1944			$PROTOCMPTERSE \
1945			  "Files in yesterday's proto area, but not today's:" \
1946			  "Files in today's proto area, but not yesterday's:" \
1947			  "Files that changed between yesterday and today:" \
1948			  ${ELIST} \
1949			  -d $REF_PROTO_LIST \
1950			  $ATLOG/proto_list_${MACH} \
1951				>> $mail_msg_file
1952		fi
1953		# Compare the build's proto list with current package
1954		# definitions to audit the quality of package definitions
1955		# and makefile install targets. Use the current exception list.
1956		PKGDEFS_LIST=""
1957		for d in $abssrcdirs; do
1958			if [ -d $d/pkgdefs ]; then
1959				PKGDEFS_LIST="$PKGDEFS_LIST -d $d/pkgdefs"
1960			fi
1961		done
1962
1963		$PROTOCMPTERSE \
1964		    "Files missing from the proto area:" \
1965		    "Files missing from packages:" \
1966		    "Inconsistencies between pkgdefs and proto area:" \
1967		    ${ELIST} \
1968		    ${PKGDEFS_LIST} \
1969		    $ATLOG/proto_list_${MACH} \
1970		    >> $mail_msg_file
1971	fi
1972fi
1973
1974if [ "$u_FLAG" = "y"  -a "$build_ok" = "y" ]; then
1975	staffer cp $ATLOG/proto_list_${MACH} \
1976		$PARENT_WS/usr/src/proto_list_${MACH}
1977fi
1978
1979# Update parent proto area if necessary. This is done now
1980# so that the proto area has either DEBUG or non-DEBUG kernels.
1981# Note that this clears out the lock file, so we can dispense with
1982# the variable now.
1983if [ "$U_FLAG" = "y" -a "$build_ok" = "y" ]; then
1984	echo "\n==== Copying proto area to $NIGHTLY_PARENT_ROOT ====\n" | \
1985	    tee -a $LOGFILE >> $mail_msg_file
1986	# The rm -rf command below produces predictable errors if
1987	# nightly is invoked from the parent's $ROOT/opt/onbld/bin,
1988	# and that directory is accessed via NFS.  This is because
1989	# deleted-but-still-open files don't actually disappear as
1990	# expected, but rather turn into .nfsXXXX junk files, leaving
1991	# the directory non-empty.  Since this is a not-unusual usage
1992	# pattern, and we still want to catch other errors here, we
1993	# take the unusal step of moving aside 'nightly' from that
1994	# directory (if we're using it).
1995	mypath=${0##*/root_$MACH/}
1996	if [ "$mypath" = $0 ]; then
1997		mypath=opt/onbld/bin/${0##*/}
1998	fi
1999	if [ $0 -ef $PARENT_WS/proto/root_$MACH/$mypath ]; then
2000		mv -f $0 $PARENT_WS/proto/root_$MACH
2001	fi
2002	rm -rf $PARENT_WS/proto/root_$MACH/*
2003	unset Ulockfile
2004	mkdir -p $NIGHTLY_PARENT_ROOT
2005	cd $ROOT
2006	( tar cf - . | ( cd $NIGHTLY_PARENT_ROOT;  umask 0; tar xpf - ) ) 2>&1 |
2007		tee -a $mail_msg_file >> $LOGFILE
2008fi
2009
2010#
2011# do shared library interface verification
2012#
2013
2014if [ "$A_FLAG" = "y" -a "$build_ok" = "y" ]; then
2015	echo "\n==== Check versioning and ABI information ====\n"  | \
2016	    tee -a $LOGFILE >> $mail_msg_file
2017
2018	rm -rf $SRC/interfaces.ref
2019	if [ -d $SRC/interfaces.out ]; then
2020		mv $SRC/interfaces.out $SRC/interfaces.ref
2021	fi
2022	rm -rf $SRC/interfaces.out
2023	mkdir -p $SRC/interfaces.out
2024
2025	intf_check -V -m -o -b $SRC/tools/abi/etc \
2026		-d $SRC/interfaces.out $ROOT 2>&1 | sort \
2027		> $SRC/interfaces.out/log
2028
2029	# report any ERROR found in log file
2030	fgrep 'ERROR' $SRC/interfaces.out/log | sed 's/^ERROR: //' | \
2031		tee -a $LOGFILE >> $mail_msg_file
2032
2033	if [ ! -d $SRC/interfaces.ref ] ; then
2034		mkdir -p $SRC/interfaces.ref
2035		if [ -d  $SRC/interfaces.out ]; then
2036			cp -r $SRC/interfaces.out/* $SRC/interfaces.ref
2037		fi
2038	fi
2039
2040	echo "\n==== Diff versioning warnings (since last build) ====\n" | \
2041	    tee -a $LOGFILE >> $mail_msg_file
2042
2043	out_vers=`grep ^VERSION $SRC/interfaces.out/log`;
2044	ref_vers=`grep ^VERSION $SRC/interfaces.ref/log`;
2045
2046	# Report any differences in WARNING messages between last
2047	# and current build.
2048	if [ "$out_vers" = "$ref_vers" ]; then
2049		diff $SRC/interfaces.ref/log $SRC/interfaces.out/log | \
2050		    fgrep 'WARNING' | sed 's/WARNING: //' | \
2051		    tee -a $LOGFILE >> $mail_msg_file
2052	fi
2053fi
2054
2055if [ "$r_FLAG" = "y" -a "$build_ok" = "y" ]; then
2056	echo "\n==== Check ELF runtime attributes ====\n" | \
2057	    tee -a $LOGFILE >> $mail_msg_file
2058
2059	LDDUSAGE="^ldd: does not support -e"
2060	LDDWRONG="wrong class"
2061	CRLERROR="^crle:"
2062	CRLECONF="^crle: configuration file:"
2063
2064	rm -f $SRC/runtime.ref
2065	if [ -f $SRC/runtime.out ]; then
2066		egrep -v "$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" \
2067			$SRC/runtime.out > $SRC/runtime.ref
2068	fi
2069
2070	# If we're doing a debug build the proto area will be left with
2071	# debuggable objects, thus don't assert -s.
2072	if [ "$D_FLAG" = "y" ]; then
2073		rtime_sflag=""
2074	else
2075		rtime_sflag="-s"
2076	fi
2077	check_rtime -d $ROOT -i -m -o $rtime_sflag $ROOT 2>&1 | \
2078	    egrep -v ": unreferenced object=$ROOT/.*/lib(w|intl|thread|pthread).so" | \
2079	    egrep -v ": unused object=$ROOT/.*/lib(w|intl|thread|pthread).so" | \
2080	    sort >$SRC/runtime.out
2081
2082	# Determine any processing errors that will affect the final output
2083	# and display these first.
2084	grep -l "$LDDUSAGE" $SRC/runtime.out > /dev/null
2085	if [ $? -eq 0 ]; then
2086	    echo "WARNING: ldd(1) does not support -e.  The version of ldd(1)" | \
2087		tee -a $LOGFILE >> $mail_msg_file
2088	    echo "on your system is old - 4390308 (s81_30) is required.\n" | \
2089		tee -a $LOGFILE >> $mail_msg_file
2090	fi
2091	grep -l "$LDDWRONG" $SRC/runtime.out > /dev/null
2092	if [ $? -eq 0 ]; then
2093	    echo "WARNING: wrong class message detected.  ldd(1) was unable" | \
2094		tee -a $LOGFILE >> $mail_msg_file
2095	    echo "to execute an object, thus it could not be checked fully." | \
2096		tee -a $LOGFILE >> $mail_msg_file
2097	    echo "Perhaps a 64-bit object was encountered on a 32-bit system," | \
2098		tee -a $LOGFILE >> $mail_msg_file
2099	    echo "or an i386 object was encountered on a sparc system?\n" | \
2100		tee -a $LOGFILE >> $mail_msg_file
2101	fi
2102	grep -l "$CRLECONF" $SRC/runtime.out > /dev/null
2103	if [ $? -eq 0 ]; then
2104	    echo "WARNING: creation of an alternative dependency cache failed." | \
2105		tee -a $LOGFILE >> $mail_msg_file
2106	    echo "Dependencies will bind to the base system libraries.\n" | \
2107		tee -a $LOGFILE >> $mail_msg_file
2108	    grep "$CRLECONF" $SRC/runtime.out | \
2109		tee -a $LOGFILE >> $mail_msg_file
2110	    grep "$CRLERROR" $SRC/runtime.out | grep -v "$CRLECONF" | \
2111		tee -a $LOGFILE >> $mail_msg_file
2112	    echo "\n" | tee -a $LOGFILE >> $mail_msg_file
2113	fi
2114
2115	egrep '<dependency no longer necessary>' $SRC/runtime.out | \
2116	    tee -a $LOGFILE >> $mail_msg_file
2117
2118	# NEEDED= and RPATH= are informational; report anything else that we
2119	# haven't already.
2120	egrep -v "NEEDED=|RPATH=|$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" \
2121	    $SRC/runtime.out | tee -a $LOGFILE >> $mail_msg_file
2122
2123	# probably should compare against a 'known ok runpaths' list
2124	if [ ! -f $SRC/runtime.ref ]; then
2125		egrep -v "$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" \
2126			$SRC/runtime.out >  $SRC/runtime.ref
2127	fi
2128
2129	echo "\n==== Diff ELF runtime attributes (since last build) ====\n" \
2130	    >> $mail_msg_file
2131
2132	egrep -v "$LDDUSAGE|$LDDWRONG|$CRLERROR|$CRLECONF" $SRC/runtime.out | \
2133	    diff $SRC/runtime.ref - >> $mail_msg_file
2134fi
2135
2136# DEBUG lint of kernel begins
2137
2138if [ "$i_CMD_LINE_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
2139	if [ "$LINTDIRS" = "" ]; then
2140		# LINTDIRS="$SRC/uts y $SRC/stand y $SRC/psm y"
2141		LINTDIRS="$SRC y"
2142	fi
2143	set $LINTDIRS
2144	while [ $# -gt 0 ]; do
2145		dolint $1 $2; shift; shift
2146	done
2147else
2148	echo "\n==== No '$MAKE lint' ====\n" >> $LOGFILE
2149fi
2150
2151# "make check" begins
2152
2153if [ "$i_CMD_LINE_FLAG" = "n" -a "$C_FLAG" = "y" ]; then
2154	# remove old check.out
2155	rm -f $SRC/check.out
2156
2157	rm -f $SRC/check-${MACH}.out
2158	cd $SRC
2159	$MAKE -ek check 2>&1 | tee -a $SRC/check-${MACH}.out >> $LOGFILE
2160	echo "\n==== cstyle/hdrchk errors ====\n" >> $mail_msg_file
2161
2162	grep ":" $SRC/check-${MACH}.out |
2163		egrep -v "Ignoring unknown host" | \
2164		sort | uniq >> $mail_msg_file
2165else
2166	echo "\n==== No '$MAKE check' ====\n" >> $LOGFILE
2167fi
2168
2169echo "\n==== Find core files ====\n" | \
2170    tee -a $LOGFILE >> $mail_msg_file
2171
2172find $abssrcdirs -name core -a -type f -exec file {} \; | \
2173	tee -a $LOGFILE >> $mail_msg_file
2174
2175if [ "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
2176	echo "\n==== Diff unreferenced files (since last build) ====\n" \
2177	    | tee -a $LOGFILE >>$mail_msg_file
2178	rm -f $SRC/unref-${MACH}.ref
2179	if [ -f $SRC/unref-${MACH}.out ]; then
2180		mv $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
2181	fi
2182
2183	findunref -t $SRC/.build.tstamp $SRC/.. \
2184	    ${TOOLS}/findunref/exception_list \
2185	    2>> $mail_msg_file | sort | \
2186	    sed -e s=^./src/=./= -e s=^./closed/=../closed/= \
2187	    > $SRC/unref-${MACH}.out
2188
2189	if [ ! -f $SRC/unref-${MACH}.ref ]; then
2190		cp $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
2191	fi
2192
2193	diff $SRC/unref-${MACH}.ref $SRC/unref-${MACH}.out >>$mail_msg_file
2194fi
2195
2196# Verify that the usual lists of files, such as exception lists,
2197# contain only valid references to files.  If the build has failed,
2198# then don't check the proto area.
2199CHECK_PATHS=${CHECK_PATHS:-y}
2200if [ "$CHECK_PATHS" = y -a "$N_FLAG" != y ]; then
2201	echo "\n==== Check lists of files ====\n" | tee -a $LOGFILE \
2202		>>$mail_msg_file
2203	arg=-b
2204	[ "$build_ok" = y ] && arg=
2205	checkpaths $arg $ROOT 2>&1 | tee -a $LOGFILE >>$mail_msg_file
2206fi
2207
2208if [ "$M_FLAG" != "y" -a "$build_ok" = y ]; then
2209	echo "\n==== Impact on file permissions ====\n" \
2210		>> $mail_msg_file
2211	#
2212	# Get pkginfo files from usr/src/pkgdefs
2213	#
2214	pmodes -qvdP \
2215	`for d in $abssrcdirs; do
2216		if [ -d "$d/pkgdefs" ]
2217		then
2218			find $d/pkgdefs -name pkginfo.tmpl -print -o -name .del\* -prune
2219		fi
2220	 done | sed -e 's:/pkginfo.tmpl$::' | sort -u ` >> $mail_msg_file
2221fi
2222
2223END_DATE=`date`
2224echo "==== Nightly $maketype build completed: $END_DATE ====" | \
2225    tee -a $LOGFILE >> $build_time_file
2226
2227typeset -Z2 minutes
2228typeset -Z2 seconds
2229
2230elapsed_time=$SECONDS
2231((hours = elapsed_time / 3600 ))
2232((minutes = elapsed_time / 60  % 60))
2233((seconds = elapsed_time % 60))
2234
2235echo "\n==== Total build time ====" | \
2236    tee -a $LOGFILE >> $build_time_file
2237echo "\nreal    ${hours}:${minutes}:${seconds}" | \
2238    tee -a $LOGFILE >> $build_time_file
2239
2240if [ "$u_FLAG" = "y" -a "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
2241	staffer cp ${SRC}/unref-${MACH}.out $PARENT_WS/usr/src/
2242
2243	#
2244	# Produce a master list of unreferenced files -- ideally, we'd
2245	# generate the master just once after all of the nightlies
2246	# have finished, but there's no simple way to know when that
2247	# will be.  Instead, we assume that we're the last nightly to
2248	# finish and merge all of the unref-${MACH}.out files in
2249	# $PARENT_WS/usr/src/.  If we are in fact the final ${MACH} to
2250	# finish, then this file will be the authoritative master
2251	# list.  Otherwise, another ${MACH}'s nightly will eventually
2252	# overwrite ours with its own master, but in the meantime our
2253	# temporary "master" will be no worse than any older master
2254	# which was already on the parent.
2255	#
2256
2257	set -- $PARENT_WS/usr/src/unref-*.out
2258	cp "$1" ${TMPDIR}/unref.merge
2259	shift
2260
2261	for unreffile; do
2262		comm -12 ${TMPDIR}/unref.merge "$unreffile" > ${TMPDIR}/unref.$$
2263		mv ${TMPDIR}/unref.$$ ${TMPDIR}/unref.merge
2264	done
2265
2266	staffer cp ${TMPDIR}/unref.merge $PARENT_WS/usr/src/unrefmaster.out
2267fi
2268
2269#
2270# All done save for the sweeping up.
2271# (whichever exit we hit here will trigger the "cleanup" trap which
2272# optionally sends mail on completion).
2273#
2274if [ "$build_ok" = "y" ]; then
2275	exit 0
2276fi
2277exit 1
2278